<?php
/**
 * Created by PhpStorm.
 * User: loyaltysolutions
 * Date: 20/06/2019
 * Time: 10:20 AM
 */

namespace App\Http\Controllers;

use App\Bookings;
use App\City;
use App\Country;
use App\ExperiencesStore;
use App\Http\Proxy\ExperienceProxy;
use App\Products;
use App\Rates;


use App\RatesDump;
use App\Traits\RatesTrait;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Schema;
use Illuminate\Support\Facades\Validator;

class GiftingOwlController
{
    use RatesTrait;
    private $experienceProxy;

    public function __construct(ExperienceProxy $ExperienceProxy)
    {
        $this->experienceProxy = $ExperienceProxy;

    }

    public function get_total_pages()
    {

        $page = 0;
        $response = $this->experienceProxy->getExperience("experiences", "&page=" . $page);

        if ($response) {
            if ($response->status == 'success') {
                $max_page = (int)($response->total / 50);

                return  $max_page;
                //return (int)$max_page;
            } else {

                return response()->json(['status' => '0', 'message' => $response->status]);

            }
        } else {

            return response()->json(['status' => '0', 'message' => 'Invalid Data returned', 'data' => $response]);
        }


    }

    // main get and save function
    public function get_save_experiences()
    {

        $get_pages= $this->get_total_pages();

        //dd($get_pages);
        //$get_pages= 3;
        if (is_numeric($get_pages)) {
            ExperiencesStore::truncate();
                $response_array = array();

            for ($x = 0; $x < $get_pages; $x++) {
                //$get_exp = $this->get_all_experiences($get_pages);
                $response = $this->experienceProxy->getExperience("experiences", "&page=" . $x);
                $s_array = array();
                if ($response) {
                    if ($response->status == 'success') {

                        if (isset($response->result)) {

                            //dd($response->result);
                            $insert_array = array();
                            foreach ($response->result as $item) {
                                //$response_array['success'][] = [
                                    $insert_array[] = [
                                    'guid' => $item->guid,
                                    'title' => $item->title,
                                    'picture' => $item->picture,
                                    'description' => $item->description,
                                    'supplier_name' => $item->supplier_name,
                                    'location_lat' => $item->location_lat,
                                    'location_lon' => $item->location_lon,
                                    'location_city' => $item->location_city,
                                    'location_state' => $item->location_state,
                                    'location_country' => $item->location_country,
                                    'google_city' => $item->google_city,
                                    'google_state_short' => $item->google_state_short,
                                    'google_state_long' => $item->google_state_long,
                                    'google_country' => $item->google_country,
                                    'currency_base' => $item->currency_base,
                                    'price' => $item->price,
                                    'sale_percentage' => $item->sale_percentage,
                                    'duration_minutes' => $item->duration_minutes,
                                    'updated' => $item->updated,
                                    'created' => $item->created,
                                    'url' => $item->url,
                                    'landingPages' => json_encode($item->landingPages),
                                    'reviews' => json_encode($item->reviews),
                                    'images' => json_encode($item->images),
                                    'page' => $x
                                ];
                            }
//                        echo (count($s_array));
//                        echo "<hr>";
                            $save_array = $this->insert_experience($insert_array);
                            //dd($s_array);

                            $s_array['page'] = $x;
                            $s_array['count'] = count($insert_array);

                            $response_array['success'][] = $s_array;
                            //dd($response_array);
                        } else {

                            $s_array['page'] = $x;
                            $s_array['count'] = 0;
                            $s_array['reason'] = "Result is not set";
                            $response_array['failed'][] = $s_array;
                        }

                    } else {
                        $s_array['page'] = $x;
                        $s_array['count'] = 0;
                        $s_array['reason'] = "Status is not success";
                        $response_array['failed'][] = $s_array;
//
                    }
//
//
                } else{

                    $s_array['page'] = $x;
                    $s_array['count'] = 0;
                    $s_array['reason'] = "Invalid response";
                    $response_array['failed'][] = $s_array;
                }
            }

            return response()->json(['status' => '1', 'message' => 'Success', 'data' =>$response_array]);

        } else {

            return response()->json(['status' => '0', 'message' => 'Invalid Total Pages']);
        }

//            if ($get_exp['status'] == 1) {
//
//
//                if (!empty($get_exp['result']['success'])) {
//                    //dd($get_exp['result']['success']);
//                    $save_array = $this->insert_experience($get_exp['result']['success']);
//
//                    if ($save_array['status'] == 1) {
//
//                        if (isset($get_exp['result']['failed'])) {
//
//                            $failed_data = $get_exp['result']['failed'];
//                            $message = "Some data failed";
//                        } else {
//
//                            $message = "Success";
//                            $failed_data = array();
//                        }
//
//                        return response()->json(['status' => '1', 'message' => $message, 'failed_data' => $failed_data]);
//
//                    } else {
//
//                        return response()->json(['status' => '0', 'message' => 'All Save failed']);
//                    }
//                } else {
//
//                    return response()->json(['status' => '0', 'message' => 'All failed Array empty']);
//                }
//
//            } else {
//
//                return response()->json($get_exp);
//            }
//
//        } else {
//
//            return response()->json(['status' => '0', 'message' => 'Invalid Total Pages']);
//        }
    }

    public function get_page_experience($page = 0)
    {

        $response = $this->experienceProxy->getExperience("experiences", "&page=" . $page);

        return ['status' => '1', 'message' => 'success', 'data' => $response->result];
    }


    public function get_all_experiences($pages)
    {

        //ExperiencesStore::truncate();
        $response_array = array();
        for ($x = 0; $x <= $pages; $x++) {
            //echo "The number is: $x <br>";
            $response = $this->experienceProxy->getExperience("experiences", "&page=" . $x);
            //dd($response);
            if ($response) {
                if ($response->status == 'success') {

                    if (isset($response->result)) {

                    //dd($response->result);
//                        $s_array = array();
                        foreach ($response->result as $item) {
                            $response_array['success'][] = [
                                //$s_array[] = [
                                'guid' => $item->guid,
                                'title' => $item->title,
                                'picture' => $item->picture,
                                'description' => $item->description,
                                'supplier_name' => $item->supplier_name,
                                'location_lat' => $item->location_lat,
                                'location_lon' => $item->location_lon,
                                'location_city' => $item->location_city,
                                'location_state' => $item->location_state,
                                'location_country' => $item->location_country,
                                'google_city' => $item->google_city,
                                'google_state_short' => $item->google_state_short,
                                'google_state_long' => $item->google_state_long,
                                'google_country' => $item->google_country,
                                'currency_base' => $item->currency_base,
                                'price' => $item->price,
                                'sale_percentage' => $item->sale_percentage,
                                'duration_minutes' => $item->duration_minutes,
                                'updated' => $item->updated,
                                'created' => $item->created,
                                'url' => $item->url,
                                'landingPages' => json_encode($item->landingPages),
                                'reviews' => json_encode($item->reviews),
                                'images' => json_encode($item->images),
                                'page' => $x
                            ];
                        }
//                        echo (count($s_array));
//                        echo "<hr>";
                        //$save_array = $this->insert_experience($s_array);
                                    //dd($s_array);
                    } else {

                        $data_array['data'] = $response;
                        $data_array['page'] = $x;
                        $response_array['failed'][] = $data_array;
                    }

                } else {
                    $data_array['data'] = $response;
                    $data_array['page'] = $x;
                    $response_array['failed'][] = $data_array;
//
                }
//
//
            } else {
                //dd($response);
                return ['status' => '0', 'message' => 'Invalid Data returned', 'data' => $response];
            }

        }
        return ['status' => '1', 'message' => 'success', 'result' => $response_array];

    }

    public function insert_experience($array)
    {

        //ExperiencesStore::truncate();
        $save_data = ExperiencesStore::insert($array);

        if (!$save_data) {
            return ['status' => '0', 'message' => 'failed'];

        } else {
            return ['status' => '1', 'message' => 'success'];
        }
    }


// Country
    public function save_country()
    {

        $get_country = $this->get_country();
        $get_unique_country = $this->get_unique_country();

        //dd($get_unique_country);

        if (!empty ($get_unique_country)) {
            $new_country = array();

            //echo json_encode($get_country);
            foreach ($get_unique_country as $country) {


                if ($country['name'] != "") {

                    if (!in_array($country['name'], array_column($get_country, 'name'))) {

                        $new_country[] = [
                            'name' => $country['name']
                        ];

                    }

                }

            }

            if (!empty($new_country)) {

                return $this->insert_country($new_country);

            } else {

                return "No new country";
            }


        } else {

            return "No record found";
        }


    }

    // get distinct country
    public function get_unique_country()
    {


        $get_unique_country = ExperiencesStore::distinct()->get(['google_country']);

        $response_array = array();
        foreach ($get_unique_country as $item) {
            $response_array[] = [
                'name' => $item->google_country
            ];
        }
        return $response_array;

    }


    public function get_country()
    {

        $country = new CountryController();
        $get_country = $country->ListCountry();
        return $get_country;
    }


    private function insert_country($array)
    {


        $save_data = Country::insert($array);

        if (!$save_data) {
            return ['status' => '0', 'message' => 'failed'];

        } else {
            return ['status' => '1', 'message' => 'success'];
        }
    }


    // City
    public function save_city()
    {

        $get_city = $this->get_city();
        $get_unique_city = $this->get_unique_city();
        $get_country = $this->get_country();


        if (!empty ($get_unique_city)) {
            $new_city = array();

            //echo json_encode($get_country);
            foreach ($get_unique_city as $city) {


                if ($city['name'] != "") {

                    foreach ($get_unique_city as $list_city) {

                        if (!in_array($list_city['name'], array_column($get_city, 'name'))) {
                            if ($list_city['name'] == $city['name']) {

//                            echo($list_city['name']);
//                            echo "<br>";
//                            echo($list_city['country']);

                                $key = array_search($list_city['country'], array_column($get_country, 'name'));

//                            echo($key);
//                            echo "<br>";
                                $new_city[] = [
                                    'name' => $city['name'],
                                    'country_id' => $get_country[$key]['id']
                                ];
                            }
                        }
                    }


                }

            }

            if (!empty($new_city)) {

                return $this->insert_city($new_city);

            } else {

                return "No new city";
            }


        } else {

            return "No record found";
        }


    }

    // get distinct city
    public function get_unique_city()
    {


        $get_unique_city = ExperiencesStore::groupBy('google_city', 'google_country')->select('google_city', 'google_country')->get();

        $response_array = array();
        foreach ($get_unique_city as $item) {
            $response_array[] = [
                'name' => $item->google_city,
                'country' => $item->google_country
            ];
        }
        return $response_array;

    }


    public function get_city()
    {

        $city = new CityController();
        $get_city = $city->ListCities();
        return $get_city;
    }


    private function insert_city($array)
    {


        $save_data = City::insert($array);

        if (!$save_data) {
            return ['status' => '0', 'message' => 'failed'];

        } else {
            return ['status' => '1', 'message' => 'success'];
        }
    }

// get experience data not in product table
    public function store_get_table()
    {
        $today = date('Y-m-d H:i:s');
        $warehouses = ExperiencesStore::whereNotIn('guid', function ($query) {
            $query->select('guid')
                ->from('products');
            //->where('id_office', '=', session('sess_id_office'));
        })->get();

        $store_data = $warehouses->toArray();

        if (!empty($store_data)) {
            $city = new CityController();
            $get_city = $city->ListCities();

            $rates = new RatesController();
            $get_rates = $rates->ListRates();

            $response_array = array();
            foreach ($store_data as $item) {


                if ($item['google_city'] != null) {
                    //dd($item);

                    $key = array_search($item['google_city'], array_column($get_city, 'name'));
                    $city_id = $get_city[$key]['id'];

                    //$key2 = array_search($item->currency_base, array_column($get_rates, 'country'));
                    $ngn_amount = $rates->convert_to_naira($get_rates, $item['currency_base'], $item['price']);

                    //dd($ngn_amount);
                    if (is_numeric($ngn_amount) && $ngn_amount > 0) {
                        $response_array[] = [
                            'guid' => $item['guid'],
                            'title' => $item['title'],
                            'picture' => $item['picture'],
                            'description' => $item['description'],
                            'supplier_name' => $item['supplier_name'],
                            'location_lat' => $item['location_lat'],
                            'location_lon' => $item['location_lon'],
                            'city_id' => $city_id,
                            'google_city' => $item['google_city'],
                            'google_state_short' => $item['google_state_short'],
                            'google_state_long' => $item['google_state_long'],
                            'google_country' => $item['google_country'],
                            'sale_percentage' => $item['sale_percentage'],
                            'duration_minutes' => $item['duration_minutes'],
                            'currency_base' => $item['currency_base'],
                            'price' => $item['price'],
                            'naira_price' => $ngn_amount,
                            'status' => 1,
                            'insert_status' => 0,
                            'update_status' => 1,
                            'created_at' => $today
                        ];
                    }
                }
            }

//            dd($response_array);
            //return $response_array;
            if (!empty($response_array)) {

                $save_product = new ProductsController();
                return $save_product->save_products($response_array);
            } else {

                return "No non-null data to save";
            }
        } else {

            return "No new data";
        }
    }





//    public function get_exchange_rate($page = 0)
//    {
//        $array = [];
//        $response = $this->experienceProxy->getExperiences("rates");
//        if ($response) {
//            if (isset($response->results[0]->rates)) {
//                foreach (json_decode($response->results[0]->rates, true) as $index => $item) {
//                    $array[] = [
//                        'country' => $index,
//                        'value' => $item
//                    ];
//                }
//            }
//        }
//
//        //Rename table
//        $date = date('ymdhs');
//        Schema::rename('rates', 'rates' . $date);
//
//        //Create table
//        Schema::create('rates', function ($table) {
//            $table->string('country')->unique();
//            $table->string('value');
//            $table->bigIncrements('id');
//        });
//        $rate = Rates::insert($array);
//
//        return response()->json($rate);
//    }


    // get experience data not in product table
    public function new_rates_data()
    {
        $today = date('Y-m-d H:i:s');
        $warehouses = RatesDump::whereNotIn('country', function ($query) {
            $query->select('country')
                ->from('rates');
            //->where('id_office', '=', session('sess_id_office'));
        })->get();

        $store_data = $warehouses->toArray();
        if (!empty($store_data)) {
            //dd($store_data);
            foreach ($store_data as $item) {
                $response_array[] = [
                    'country' => $item['country'],
                    'value' => $item['value'],
                    'insert_status' => 0,
                    'update_status' => 1


                ];

            }
            if (!empty($response_array)) {

                $save_product = new RatesController();
                return $save_product->save_rates($response_array);
            } else {

                return "No non-null data to save";
            }
        } else {

            return "No new Rates";
        }
    }


    public function get_exchange_rate($page = 0)
    {
        $array = [];
        $response = $this->experienceProxy->getExperiences("rates","");
        if ($response) {
            if (isset($response->results[0]->rates)) {
                foreach (json_decode($response->results[0]->rates, true) as $index => $item) {
                    $array[] = [
                        'country' => $index,
                        'value' => $item
                    ];
                }
            }
        }


        RatesDump::truncate();

        $rate = RatesDump::insert($array);

        return response()->json($rate);
    }

    public function get_single_experience(Request $request)
    {

        $valid = Validator::make($request->all(), [
            'eguid' => 'required',
        ]);

        if($valid->fails()){
            return response()->json([
                'data' => [], 'message' => $valid->errors()->first(), 'status' => '400'], 400);
        }

        $product = Products::where('guid', $request['eguid']);
        if ($product->exists()) {
            $response = $this->experienceProxy->getExperience("experience", "&eguid=" . $request['eguid']);

            //Filter properties
            $data = collect($response->experience)->only(
                'guid',
                'name',
                'title',
                'description',
                'location_city',
                'location_country',
                'location_country_code',
                'location_address',
                'location_lat',
                'location_lon',
                'location_zoom',
                'duration_minutes',
                'age',
                'gender',
                'group_minimum',
                'group_maximum',
                'google_city',
                'google_state_long',
                'google_state_short',
                'google_country',
                'picture',
                'images',
                'rating'
            );

            //Add price to data object from product table
            $data->put('price', $product->first()->naira_price);

            //Add extra_info to data object from product table
            $data->put('extra_info', $response->extra_info);

            //Add images to data object from product table
            $data->put('images', $response->images);

            //Add tags to data object from product table
            $data->put('tags', $response->tags);

            //Add extras to data object from product table
            $data->put('extras', $response->extras);

            return response()->json([
                'data' => $data,
                'status' => 200,
                'message' => 'Experience loaded'
            ], 200);
        } else {
            return response()->json([
                'data' => [],
                'status' => 400,
                'message' => 'Experience unavailable'
            ], 400);
        }

    }

    public function getAvailability(Request $request)
    {
        $data = [];
        $product = Products::where('guid', $request['eguid']);
        if ($product->exists()) {
            $response = $this->experienceProxy->getExperience("availabilities", "&eguid=" . $request['eguid']);

            if ($response) {
                $rates = $this->ListRates();
                $product = $product->select('currency_base', 'title')->first();
                foreach ($response->availabilities as $item) {
                    $data[] = [
                        'start_time' => $item->start_time,
                        'start_time_local' => $item->start_time_local,
                        'end_time' => $item->end_time,
                        'end_time_local' => $item->end_time_local,
                        'bp_guid' => $item->bp_guid,
                        'seats_available' => $item->seats_available,
                        'updated' => $item->updated,
                        'price_options' => $this->processPriceOptions(
                            $rates,
                            $item->price_options,
                            $product->currency_base
                        ),
                        'guid' => $item->guid,
                        'eguid' => $item->eguid,
                        'is_shallow' => $item->is_shallow,
                    ];
                }
                return response()->json([
                    'data' => $data,
                    'activity_name' => $product->title,
                    'status' => 200,
                    'message' => 'Data loaded'
                ], 200);
            } else {
                return response()->json([
                    'data' => [],
                    'status' => 400,
                    'message' => 'Data unavailable'
                ], 400);
            }

        } else {
            return response()->json([
                'data' => [],
                'status' => 400,
                'message' => 'Data unavailable'
            ], 400);
        }

    }

    public function getExperienceBookingForm(Request $request)
    {
        $data = [];
        $product = Products::where('guid', $request['eguid']);
        if ($product->exists()) {
            $response = $this->experienceProxy->getExperience("experience-forms", "&eguid=" . $request['eguid']);
//            dd($response);
            if ($response) {
                foreach ($response as $item) {
//                    dd($item->eguid);
                    $data[] = [
                        'guid' => $item->guid,
                        'eguid' => isset($item->eguid) ? $item->eguid : "",
                        'index' => $item->index,
                        'label' => $item->label,
                        'input_type' => $item->input_type,
                        'required_per_participant' => $item->required_per_participant,
                        'required_per_booking' => $item->required_per_booking,
                        'visible_per_participant' => $item->visible_per_participant,
                        'visible_per_booking' => $item->visible_per_booking,
                        'list_options' => isset($item->list_options) ? $item->list_options : "",
                        'updated' => isset($item->updated) ? $item->updated : "",
                        'bp_guid' => $item->bp_guid
                    ];
                }
                return response()->json([
                    'data' => $response,
                    'status' => 200,
                    'message' => 'Data loaded'
                ], 200);
            } else {
                return response()->json([
                    'data' => [],
                    'status' => 400,
                    'message' => 'Data unavailable'
                ], 400);
            }
        } else {
            return response()->json([
                'data' => [],
                'status' => 400,
                'message' => 'Data unavailable'
            ], 400);
        }
    }


    public function bookExperience(Request $request)
    {

        $validator = Validator::make($request->all(), [
            'eguid' => 'required',
            'bp_guid' => 'required',
            'currencyType' => 'required',
            'total' => 'required',
            'total.currency' => 'required',
            'total.currencyType' => 'required',
            'customer' => 'required',
            'customer.email' => 'required|email',
            'customer.given_name' => 'required',
            'customer.family_name' => 'required',
            'customer.mobile' => 'required',
            'priceOptions' => 'required',
            'priceOptions.*.bp_po_guid' => 'required',
            'priceOptions.*.label' => 'required',
            'priceOptions.*.price' => 'required',
            'priceOptions.*.seats_used' => 'required',
            'priceOptions.*.seats_booked' => 'required',
            'priceOptions.*.count' => 'required',
            'forms' => 'required',
            'participantForms' => 'required',
//            'extras' => 'required'
        ]);


        $records =[
            'guid'=>$request->eguid,
            'currencyType'=>$request->total['currencyType'],
            'total'=>$request->total['currency'],
            'unit_price'=>$request->priceOptions[0]['price'],
            'qty'=>$request->priceOptions[0]['count']



        ];

        $save_booking = $this->insert_booking($records);

        if ($save_booking['status'] == 1) {
            $payload = [
                'eguid' => $request->eguid,
                'session' => $request->input('session'),
                'bp_guid' => $request->bp_guid,
                'currencyType' => $request->currencyType,
                'total' => [
                    'currency' => $save_booking['price'],
                    'currencyType' => $request->total['currencyType']
                ],
                'customer' => $request->customer,
                'priceOptions' => $request->priceOptions,
                'forms' => $request->forms,
                'participantForms' => $request->participantForms,
                'extras' => [],
            ];

            if ($validator->fails()) {
                return response()->json([
                    'data' => [], 'message' => $validator->errors()->first(), 'status' => '400'], 400);
            }

            $response = $this->experienceProxy->bookExperience("book", "", $payload);

            if ($response) {
                return response()->json([
                    'data' => $response,
                    'status' => 200,
                    'message' => 'Booking successful'
                ], 200);
            } else {
                return response()->json([
                    'data' => [],
                    'status' => 400,
                    'message' => 'Booking failed'
                ], 400);
            }
        } else{

            return response()->json([
                'data' => [],
                'status' => 400,
                'message' => 'Booking failed. Unable to save record'
            ], 400);

        }
    }


    public function insert_booking($records){

        $data = new Bookings();
//        $data->guid = "1234";
//        $data->currency_base= "AUD";
//        $data->unit_price = "123";
//        $data->total_price= "256.78904783957890587776987908362564723694162";
//        $data->quantity = "1";

        $data->guid = $records['guid'];
        $data->currency_base= $records['currencyType'];
        $data->unit_price = $records['unit_price'];
        $data->total_price= $records['total'];
        $data->quantity = $records['qty'];
        if ($data->save()){

            $insertedId = $data->id;

            $bookings = Bookings::find($insertedId);
            //dd($bookings);
            $currency_price = $bookings->total_price;
            //$product = Products::where('guid', $request['eguid']);


            return ['status' => '1', 'message' => 'success', 'last_id' => $insertedId, 'price' => (float)$currency_price];
        } else {

            return ['status' => '0', 'message' => 'Failed'];
        }




    }
}

