<?php
/**
 * Created by PhpStorm.
 * User: loyaltysolutions
 * Date: 20/06/2019
 * Time: 2:19 AM
 */

namespace App\Http\Controllers;

use App\Rates;
use App\RatesDump;
use Illuminate\Http\Request;

use Illuminate\Support\Facades\Schema;

class RatesController extends Controller
{

    public function test(){
        $dd = $this->convert_to_naira($this->ListRates(), "NGN", 263596.76);
        return response()->json($dd);
    }
    public function ListRates(){

        //$city = new City();
        $list_rates = Rates::query()->get();
        return $list_rates->toArray();

    }



    public function convert_to_naira ($rates_array, $base_currency, $base_amount){

        $key = array_search('NGN', array_column($rates_array, 'country'));
        $naira_value = $rates_array[$key]['value'];

//        $key2 = array_search('AUD', array_column($rates_array, 'country'));
//        $aud_value = $rates_array[$key2]['value'];

        $key3 = array_search($base_currency, array_column($rates_array, 'country'));
        $base_value = $rates_array[$key3]['value'];

//        if ($base_currency == 'AUD'){

            $amount = $this->convert_ngn_currency($naira_value, $base_value, $base_amount);

//        } else {
//
//
//            $key3 = array_search($base_currency, array_column($rates_array, 'country'));
//            $base_value = $rates_array[$key3]['value'];
//
//            if ($base_value > 0){
//
//                $amount = $this->convert_from_other($naira_value, $aud_value, $base_value, $base_amount);
//
//            } else {
//
//                $amount = "Invalid amount";
//            }
//        }

        return $amount;

    }

    private function convert_to_aud ($aud_rate, $base_rate, $base_amount){

        $aud_amount = $base_amount * ($aud_rate / $base_rate);

        return round($aud_amount, 2);


    }


    private function convert_ngn_currency ($ngn_rate, $base_rate, $base_amount){

        $ngn_amount = $base_amount * ($ngn_rate/$base_rate);

        return round($ngn_amount, 2);

    }

    private function convert_ngn_aud ($ngn_rate, $aud_rate, $aud_amount){

        $ngn_amount = $aud_amount * ($ngn_rate/$aud_rate);

        return round($ngn_amount, 2);

    }

    private function  convert_from_other($ngn_rate, $aud_rate, $base_rate, $base_amount){

        $aud_amount = $this->convert_to_aud($aud_rate, $base_rate, $base_amount);

        $ngn_amount = $this->convert_ngn_aud($ngn_rate, $aud_rate, $aud_amount);

        return $ngn_amount;

    }


    public function save_rates($array){

        $save_data = Rates::insert($array);

        if(!$save_data){
            return ['status' => '0', 'message' => 'failed'];

        } else {
            return ['status' => '1', 'message' => 'success'];
        }

    }


    public function get_changed_rates(){

        $new_rates = Rates::where('update_status', 0)->get();
        //dd($new_rates);
        return $new_rates->toArray();

    }

    public function change_update_status_used (){
        $today = date('Y-m-d H:i:s');
        $update_rates = Rates::where('update_status', 0)->update(['update_status' => 1,'updated_at' => $today] );

        if($update_rates) {
            return ['status' => '1', 'message' => 'success'];

        } else {

            return ['status' => '0', 'message' => 'failed'];
        }


    }

    public function update_rates(){

        $changed_rates = RatesDump::whereIn('country', function ($query) {
            $query->select('country')
                ->from('rates')
                ->whereRaw('rates.value != rates_dump.value');
        })->get();

        //dd($changed_rates);
        $update_data = $changed_rates->toArray();
        //dd($update_data);
        if(!empty($update_data)){

            $x=0;
            foreach ($update_data as $items) {

                $x++;


                $update_rates = Rates::where('country', $items['country'])->update(['update_status' => 0, 'value' => $items['value']] );
//                        dd($update_products);
//                        dd($naira);
            }

            return "Update rates check complete (".$x.")";
        } else {

            return "No data to update";
        }
    }
}