<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;

class ExternalAccessMiddleware
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
//        $token = Hash::make('123456');
//        dd($token);
//
//        DB::table('company')->where('id', 1)->update(['token' => $token]);

        if($request->hasHeader('token')){
    

            $validate = $this->validateAccount($request->header('token'), 1);

            if($validate->status == 'success') {
                \App\LogActivity::addLog(
                    "",
                    "Access",
                    "Access",
                    "",
                    null,
                    "success",
                    "Token valid",
                    json_encode($request->all()),
                    "",
                    $validate->data->id,
                    $validate->data->name
                );
                return $next($request);
            }
            \App\LogActivity::addLog(
                "",
                "Access",
                "Access",
                "",
                null,
                "fail",
                "Token invalid",
                json_encode($request->all()),
                "",
                null,
                null
            );
            return response()->json(['message' => 'Token invalid', 'status' => '400'], 400);
        }else{
            \App\LogActivity::addLog(
                "",
                "Access",
                "Access",
                "",
                null,
                "fail",
                "Token invalid",
                json_encode($request->all()),
                "",
                null,
                null
            );
            return response()->json(['message' => 'Token unavailable', 'status' => '400'], 400);
        }

    }

    /**
     * @param $token
     * @param $access_id
     * @return object
     */
    private function validateAccount($token, $access_id){
        $check = DB::table('company')->where('id', $access_id);

        if($check->exists()){
            if(Hash::check($token, $check->first()->token)) {
                return (object)['status' => 'success', 'data' => $check->first()];
            }
            return (object)['status' => 'fail', 'data' => []];
        }else{
            return (object)['status' => 'fail', 'data' => []];
        }
    }
}
