<?php
/**
 * Created by PhpStorm.
 * User: loyaltysolutions
 * Date: 16/07/2019
 * Time: 9:06 AM
 */

namespace App\Traits;


use App\Rates;

trait RatesTrait
{
    public function ListRates(){
        $list_rates = Rates::query()->get();
        return $list_rates->toArray();
    }


    public function processPriceOptions($rates, $data, $currency_base){
        $array = [];
        if($data){
            foreach ($data as $item){
                if(isset($item->minAge)){
                    $minAge = $item->minAge;
                } else {
                    $minAge = 1;
                }

                if(isset($item->maxAge)){
                    $maxAge = $item->maxAge;
                } else {
                    $maxAge = 150;
                }
                $array[] = (object)[
                  'label' => $item->label,
                    'bp_po_guid'=> $item->bp_po_guid,

                  'minAge' => $minAge,
                  'maxAge' => $maxAge,
                  'price_base' => $item->price,
                  'price' => $this->convert_to_naira($rates,$currency_base,$item->price),
                  'seats_used' => $item->seats_used,
                  'currency_base' => $currency_base,
                ];
            }
        }
        return $array;
    }

    public function convert_to_naira ($rates_array, $base_currency, $base_amount){

        $key = array_search('NGN', array_column($rates_array, 'country'));
        $naira_value = $rates_array[$key]['value'];

        $key3 = array_search($base_currency, array_column($rates_array, 'country'));
        $base_value = $rates_array[$key3]['value'];


        $amount = $this->convert_ngn_currency($naira_value, $base_value, $base_amount);



        return $amount;

    }

    private function convert_ngn_currency ($ngn_rate, $base_rate, $base_amount){

        $ngn_amount = $base_amount * ($ngn_rate/$base_rate);

        return round($ngn_amount, 2);

    }


}