<?php



$router->get('/', function () use ($router) {
    return $router->app->version();
});
$router->group(['prefix' => 'api', 'middleware' => 'extaccess'], function () use ($router) {
    $router->post('single_experience', 'GiftingOwlController@get_single_experience');
    $router->get('get_countries', 'CountryController@Index');
    $router->post('get_cities', 'CityController@Index');
    $router->post('get_experiences_by_city', 'ProductsController@get_experiences_by_city');
    $router->post('get_experiences_availability', 'GiftingOwlController@getAvailability');
    $router->post('get_experience_booking_form', 'GiftingOwlController@getExperienceBookingForm');
    $router->post('get_experiences_booking_form', 'GiftingOwlController@getExperienceBookingForm');
    $router->post('book_experience', 'GiftingOwlController@bookExperience');

    //Extra
    $router->post('store_popular_cities', 'ProductsController@store_popular_cities');
    $router->post('delete_popular_cities', 'ProductsController@delete_popular_cities');
    $router->post('update_popular_cities', 'ProductsController@update_popular_cities');
    $router->get('get_popular_cities', 'ProductsController@get_popular_cities');


});

$router->group(['prefix' => 'gift'], function () use ($router) {

    //Rates
    //store rates in rates dump
    $router->get('get_exchange_rate', 'GiftingOwlController@get_exchange_rate');
    //get added new rates
    $router->get('new_rates', 'GiftingOwlController@new_rates_data');
    //update exchange rates
    $router->get('update_exchange_rates', 'RatesController@update_rates');

    //Products
    //update price of products that the exchange rate has changed
    $router->get('update_product_rate_prices', 'ProductsController@update_product_rates');
    //update products that the price has changed
    $router->get('update_product_price', 'ProductsController@update_product_prices');
    //disable products that do not exist
    $router->get('disable_list_product', 'ProductsController@exist_disable_products');


    //Experiences
    //Save all api experiences
    $router->get('save_experience', 'GiftingOwlController@get_save_experiences');
    //save unique countries experiencestore
    $router->get('save_country', 'GiftingOwlController@save_country');

    //save unique cities from experiencestore
    $router->get('save_city', 'GiftingOwlController@save_city');
    //get unique products and save in products table
    $router->get('list_compare', 'GiftingOwlController@store_get_table');

    //Extra
    //list experiences from api by page
    $router->get('get_experiences/{pages}', 'GiftingOwlController@get_all_experiences');



    //$router->get('test', 'RatesController@test');
    //$router->get('all_experiences', 'GiftingOwlController@get_experiences');
//    $router->get('get_exchange_rate', 'GiftingOwlController@get_exchange_rate');
//    $router->get('get_experience_total', 'GiftingOwlController@get_total_pages');

//    $router->get('get_page_experience/{page}', 'GiftingOwlController@get_page_experience');
//    $router->get('insert_experience', 'GiftingOwlController@insert_experience');

//    $router->get('get_country', 'GiftingOwlController@get_unique_country');
//    $router->get('list_country', 'CountryController@ListCountry');
//    $router->get('country', 'GiftingOwlController@get_country');
//    $router->get('save_experience', 'GiftingOwlController@get_save_experiences');
//    $router->get('list_city', 'CityController@ListCities');


    //$router->get('save_booking', 'GiftingOwlController@insert_booking');
//    $router->get('experiences/page/{page}/limit/{limit}', function ($page, $limit)    {

});